/* NOM........  des.h						   */
/* OBJET......  DES Encryption/Decryption */
/* PROJET.....	 SFP V.1                   */
/* REFERENCES.                            */
/* VERSION....  1.0                       */
/* HISTORIQUE.  								   */
/**/




/*--------------------------------------------------------------
 *	    Declaration de Fonctions
 *--------------------------------------------------------------
 */
void	DesEncrypt(		/* DES Encryption */
			unsigned char*,			/* Entry (8 bytes, Clear Data) */
			unsigned char*,			/* Key (8 bytes) */
			unsigned char*);			/* Output (8 bytes, Encrypted Entry) */
void	DesDecrypt(		/* DES Decryption */
			unsigned char*,			/* Entry (8 bytes, Encrypted Entry) */
			unsigned char*,			/* Key (8 bytes) */
			unsigned char*);			/* Output (8 bytes, Clear Data) */
void	TDesEncrypt(	/* Triple DES Encryption */
			unsigned char*,			/* Entry (8 bytes, Clear Data) */
			unsigned char*,			/* Key (16 bytes) */
			unsigned char*);			/* Output (8 bytes, Encrypted Entry) */
void	TDesDecrypt(	/* Triple DES Decryption */
			unsigned char*,			/* Entry (8 bytes, Encrypted Entry) */
			unsigned char*,			/* Key (16 bytes) */
			unsigned char*);			/* Output (8 bytes, Clear Data) */
void	EncryptCBC(		/* DES CBC Encryption */
			unsigned char*,			/* Key (8 bytes) */
			unsigned char*,			/* Data to Encrypt */
			int);				/* Data Lebgth (8*x) */
void	DecryptCBC(		/* DES CBC Decryption */
			unsigned char*,			/* Key (8 bytes) */
			unsigned char*,			/* Data to Decrypt */
			int);				/* Data Lebgth (8*x) */
void	TDesEncryptCBC(	/* Triple DES CBC Encryption */
			unsigned char*,				/* Key (8 bytes) */
			unsigned char*,				/* Data to Encrypt */
			int,					/* Data Lebgth (8*x) */
			unsigned char*);				/* Initial Vector */
void	TDesDecryptCBC(	/* Triple DES CBC Decryption */
			unsigned char*,				/* Key (8 bytes) */
			unsigned char*,				/* Data to Decrypt */
			int,					/* Data Lebgth (8*x) */
			unsigned char*);				/* Initial Vector */
void GenKs(unsigned char*);		/* Reconstitution of Ks (8 bytes) */
